From e67bcf59fc6e1698ff7625bfda273d2e2b5ab00a Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Sep 07 2020 06:50:44 +0000
Subject: [PATCH 862/2232] Expand unsafety on extern C++ functions


---

diff --git a/macro/src/expand.rs b/macro/src/expand.rs
index 2f797b0..879431e 100644
--- a/macro/src/expand.rs
+++ b/macro/src/expand.rs
@@ -399,17 +399,19 @@ fn expand_cxx_function_shim(namespace: &Namespace, efn: &ExternFn, types: &Types
         })
     }
     .unwrap_or(call);
+    let mut dispatch = quote!(#setup #expr);
+    let unsafety = &efn.sig.unsafety;
+    if unsafety.is_none() {
+        dispatch = quote!(unsafe { #dispatch });
+    }
     let function_shim = quote! {
         #doc
-        pub fn #ident(#(#all_args,)*) #ret {
+        pub #unsafety fn #ident(#(#all_args,)*) #ret {
             extern "C" {
                 #decl
             }
             #trampolines
-            unsafe {
-                #setup
-                #expr
-            }
+            #dispatch
         }
     };
     match &efn.receiver {

